/*
   Watch6 ARM9 Code: queue.c
   Maarten Pennings - 2008 jan 6
   Split-off from watch5 main file.
*/

#include "nds.h"
#include "queue.h"


#define QSIZE 16
pTransferSoundData qData[QSIZE];
int qStart;
int qEnd;
// Queue is filled from and including qStart up to and excluding qEnd (with wrap around).
// We will always leave at least one position free in qData,
// because completely filling would mean qStart=qEnd.
// This condition is already reserved for the empty queue.


void qInit(void) {
  qStart=0; // any value [0..QSIZE) will do
  qEnd=qStart;
}


int qSize(void) {
  return (qEnd+QSIZE-qStart) % QSIZE;
}


int qEmpty(void) {
  return qStart==qEnd;
}


void qAdd( pTransferSoundData item ) {
  int qEnd2= (qEnd+1) % QSIZE;
  if( qEnd2==qStart ) {
    // This should not happen.
    // If it does, ignore addition.
  } else {
    qData[qEnd]= item;
    qEnd= qEnd2;
  }
}


pTransferSoundData qGet() {
  pTransferSoundData result;
  if( qEmpty() ) {
    // This should not happen.
    result= 0;
    // If it does, return an empty fragment.
  } else {
    int qStart2= (qStart+1) % QSIZE;
    result= qData[qStart];
    qStart= qStart2;
  }
  return result;
}
